#ifndef SICONOSCONFIG_H
#define SICONOSCONFIG_H

#define WITH_CMAKE
#define HAVE_SICONOS_KERNEL
#define HAVE_SICONOS_IO
#define HAVE_SICONOS_MECHANICS
#define HAVE_SICONOS_CONTROL
/* #undef HAVE_PATHFERRIS */
/* #undef HAVE_PATHVI */
#define HAVE_SORT
/* #undef HAVE_QL0001 */
/* #undef HAVE_MLCPSIMPLEX */
/* #undef HAVE_TIME_H */
/* #undef HAVE_SYSTIMES_H */
/* #undef HAVE_MPI */
#define WITH_MUMPS
/* #undef WITH_UMFPACK */
/* #undef WITH_SUPERLU */
/* #undef WITH_SUPERLU_MT */
/* #undef WITH_SUPERLU_dist */
/* #undef WITH_MKL_PARDISO */
/* #undef WITH_MKL_SPBLAS */
/* #undef SICONOS_MKL_32 */
/* #undef SICONOS_MKL_64 */
/* #undef WITH_TIMERS */
/* #undef DUMP_PROBLEM */
#define WITH_FCLIB
/* #undef BUILD_AS_CPP */
#define WITH_LPSOLVE
#define HAS_EXTREME_POINT_ALGO
/* #undef SICONOS_HAVE_VTK */
/* #undef SICONOS_HAVE_BULLET */
/* #undef SICONOS_HAS_OCE */
/* #undef HAVE_SERIALIZATION */
#define WITH_SERIALIZATION
/* #undef HAVE_GENERATION */
/* #undef WITH_HDF5 */
/* #undef WITH_OPENMP */
#define HAS_FORTRAN

// Is cblas available? 
#define HAS_CBLAS

// Where does cblas comes from? 
/* #undef HAS_MKL_CBLAS */
/* #undef HAS_ACCELERATE */
#define HAS_ATLAS_CBLAS 
/* #undef HAS_OpenBLAS */
/* #undef HAS_GenericCBLAS */

// Which Lapack? 
/* #undef HAS_MKL_LAPACKE */
#define HAS_ATLAS_LAPACK
/* #undef HAS_MATLAB_LAPACK */
/* #undef HAS_LAPACKE */
#define HAS_CLAPACK  // clapack.h has been found
/* #undef HAS_OpenBLAS_LAPACK */

// Which functions are defined in lapack? 
/* #undef HAS_LAPACK_DGESVD */
/* #undef HAS_LAPACK_DTRTRS */
/* #undef HAS_LAPACK_DGELS */

// Some definitions required for boost numeric_bindings
#if defined(HAS_CBLAS)
#define BOOST_NUMERIC_BINDINGS_BLAS_CBLAS
#endif

#if defined(HAS_MKL_CBLAS)
#define BOOST_NUMERIC_BINDINGS_BLAS_MKL
#endif

// Gams stuff
/* #undef GAMS_MODELS_SOURCE_DIR */
/* #undef GAMS_MODELS_SHARE_DIR */
/* #undef GAMS_DIR */
/* #undef HAVE_GAMS_C_API */

// Which version of C++ was used to compile siconos, needed for swig
#define SICONOS_CXXVERSION 201402L
#define SICONOS_USE_BOOST_FOR_CXX11
#define SICONOS_USE_MAP_FOR_HASH
#define SICONOS_STD_SHARED_PTR
#define SICONOS_STD_ARRAY
#define SICONOS_STD_UNORDERED_MAP
#define SICONOS_STD_TUPLE
#define SICONOS_STD_TO_STRING
#define SICONOS_STD_FUNCTIONAL

// are int 64 bits longs
#define SICONOS_INT64

// use to force 32 bits int when creating numpy array
// Useful to support old scipy version (< 0.14.0)
/* #undef SICONOS_FORCE_NPY_INT32 */

// on opensuse 42.3 Stdxx.h, failure with cxx11 and using std::isnan
/* #undef SICONOS_STD_ISNAN_ALREADY_HERE_AND_I_DO_NOT_KNOW_WHY */

#endif
